#include "amc.h"
#include "progeny.h"

static AM_CONTEXT t;
static AM_CONTEXT a;
static AM_CONTEXT *gaps;

void ancestor(AM_CONTEXT context, int numvar) {
  int numgaps = 0;
  int i;
  a = context;
  gaps = (AM_CONTEXT *) calloc(numvar, sizeof(AM_CONTEXT));
  for (i = 1 << (numvar - 1); i; i >>= 1) {
    if (!(i & context))
      gaps[numgaps++] = i;
  }
  t = 1 << numgaps;
}

AM_CONTEXT descendant(void) {
  int i;
  AM_CONTEXT tt, flip;
  --t;
  if (!t) {
    free(gaps);
    return 0;
  }
  for(i = 0, tt = t; !(tt & 1); tt >>= 1, ++i);
  flip = gaps[i];
  a = (a & flip ? a & ~flip : a | flip);
  return a;
}
